Index: /branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman13_.cs
===================================================================
--- /branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman13_.cs	(revision 17672)
+++ /branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman13_.cs	(revision 17672)
@@ -0,0 +1,83 @@
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public class Feynman9 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman9() : this((int) DateTime.Now.Ticks, 10000, 10000, null) { }
+
+    public Feynman9(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+      noiseRatio      = null;
+    }
+
+    public Feynman9(int seed, int trainingSamples, int testSamples, double? noiseRatio) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+      this.noiseRatio      = noiseRatio;
+    }
+
+    public override string Name {
+      get {
+        return string.Format("I.13.4 1/2*m*(v**2+u**2+w**2) | {0} samples | noise ({1})", trainingSamples,
+          noiseRatio == null ? "no noise" : noiseRatio.ToString());
+      }
+    }
+
+    protected override string TargetVariable { get { return noiseRatio == null ? "K" : "K_noise"; } }
+
+    protected override string[] VariableNames {
+      get { return new[] {"m", "v", "u", "w", noiseRatio == null ? "K" : "K_noise"}; }
+    }
+
+    protected override string[] AllowedInputVariables { get { return new[] {"m", "v", "u", "w"}; } }
+
+    public int Seed { get; private set; }
+
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
+
+    protected override List<List<double>> GenerateValues() {
+      var rand = new MersenneTwister((uint) Seed);
+
+      var data = new List<List<double>>();
+      var m    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var v    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var u    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var w    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+
+      var K = new List<double>();
+
+      data.Add(m);
+      data.Add(v);
+      data.Add(u);
+      data.Add(w);
+      data.Add(K);
+
+      for (var i = 0; i < m.Count; i++) {
+        var res = 1.0 / 2 * m[i] * (Math.Pow(v[i], 2) + Math.Pow(u[i], 2) + Math.Pow(w[i], 2));
+        K.Add(res);
+      }
+
+      if (noiseRatio != null) {
+        var K_noise     = new List<double>();
+        var sigma_noise = (double) noiseRatio * K.StandardDeviationPop();
+        K_noise.AddRange(K.Select(md => md + NormalDistributedRandom.NextDouble(rand, 0, sigma_noise)));
+        data.Remove(K);
+        data.Add(K_noise);
+      }
+
+      return data;
+    }
+  }
+}
Index: anches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman9.cs
===================================================================
--- /branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman9.cs	(revision 17671)
+++ 	(revision )
@@ -1,83 +1,0 @@
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Common;
-using HeuristicLab.Random;
-
-namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman9 : FeynmanDescriptor {
-    private readonly int testSamples;
-    private readonly int trainingSamples;
-
-    public Feynman9() : this((int) DateTime.Now.Ticks, 10000, 10000, null) { }
-
-    public Feynman9(int seed) {
-      Seed            = seed;
-      trainingSamples = 10000;
-      testSamples     = 10000;
-      noiseRatio      = null;
-    }
-
-    public Feynman9(int seed, int trainingSamples, int testSamples, double? noiseRatio) {
-      Seed                 = seed;
-      this.trainingSamples = trainingSamples;
-      this.testSamples     = testSamples;
-      this.noiseRatio      = noiseRatio;
-    }
-
-    public override string Name {
-      get {
-        return string.Format("I.13.4 1/2*m*(v**2+u**2+w**2) | {0} samples | noise ({1})", trainingSamples,
-          noiseRatio == null ? "no noise" : noiseRatio.ToString());
-      }
-    }
-
-    protected override string TargetVariable { get { return noiseRatio == null ? "K" : "K_noise"; } }
-
-    protected override string[] VariableNames {
-      get { return new[] {"m", "v", "u", "w", noiseRatio == null ? "K" : "K_noise"}; }
-    }
-
-    protected override string[] AllowedInputVariables { get { return new[] {"m", "v", "u", "w"}; } }
-
-    public int Seed { get; private set; }
-
-    protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
-    protected override int TestPartitionStart { get { return trainingSamples; } }
-    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
-
-    protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint) Seed);
-
-      var data = new List<List<double>>();
-      var m    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var v    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var u    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var w    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-
-      var K = new List<double>();
-
-      data.Add(m);
-      data.Add(v);
-      data.Add(u);
-      data.Add(w);
-      data.Add(K);
-
-      for (var i = 0; i < m.Count; i++) {
-        var res = 1.0 / 2 * m[i] * (Math.Pow(v[i], 2) + Math.Pow(u[i], 2) + Math.Pow(w[i], 2));
-        K.Add(res);
-      }
-
-      if (noiseRatio != null) {
-        var K_noise     = new List<double>();
-        var sigma_noise = (double) noiseRatio * K.StandardDeviationPop();
-        K_noise.AddRange(K.Select(md => md + NormalDistributedRandom.NextDouble(rand, 0, sigma_noise)));
-        data.Remove(K);
-        data.Add(K_noise);
-      }
-
-      return data;
-    }
-  }
-}